﻿// JavaScript Document
/**
 * @author Claire Griese <claire.griese@riosalado.edu> 
 * Chris Patrick <chris.patrick@riosalado.edu>
 * @version 0.53
 * @since 2012-09-20
 *
 * @author Claire Griese <claire.griese@riosalado.edu>
 * @version 0.55
 * @since 2013_03_25
 *
 * @version 0.56
   @since 2013_05_08
 */
 
//SET THIS - "long" or "short" DEFAULT="short" (clickHandler) 

var termLength = "";
//

var wordArray = new Array();
var defArray = new Array();
var currentWordIndex = 0;
var animationTimer = 900;
	
// NOTE: The maximum amount of characters for each card in "short" is about 400.
	
	
var wordCardTitleText = "TERM";
var defCardTitleText = "DEFINITION";					 
var titleLabel;
var cardLength;
var wordCard;
var defCard;
var controls;
var controlsCount;
var backButton;
var nextButton;
var cardState = "defIn";
var titleText = "title"; //5/8/2013 var will hold text pulled from xml
//var titleText = "WRKDEV100-20010 – Lesson 1"; //deprecated - title is now set in the index.html file and auto-inserted by tool


$(document).ready(function(){
	
	loadXML();
	init();
	

});

function loadXML() {
/*The following code segment loads an XML file of terms and definitions using this format:

	<?xml version="1.0">
	<terms>
		<term id="INSERT TERM">
			<definition>INSERT DEFINITION</definition>
		</term>
	</terms>

*/
 
	$.ajax({
		type: "GET",
		url: "terms.xml",
		dataType: "xml",
		cache: false,
		async: false, 
		success: function(xml) {
			
			termCount = 0;	
			
			$(xml).find('lengthVar').each(function() {
				termLength = $(this).text();
				
			});
		   
		   $(xml).find('activityTitle').each(function() {
			  // titleText = $(this).find('activityTitle').text();
			titleText = $(this).text();
			   
		   });
		   
		   
		
		
			
			$(xml).find('term').each(function(){
				
				var ourTerm = $(this).find('ourTerm').text();
				var def = $(this).find('definition').text();
				
				wordArray[termCount] = ourTerm;
				defArray[termCount] = def;
				termCount++
			});
			cardLength = termCount;
		},
		
		error: function() {
        	alert('Failed to load XML');
		}

	});

}

function init()
{
	
	
	wordCard = document.getElementById('wordCard');
	defCard = document.getElementById('defCard');
	controls = document.getElementById('dashboard');
	controlsCount = document.getElementById('dashboardCount');
	

	initLabels();
	
	if(termLength == "long"){
		
		  //change animation function
		  
		  $(wordCard).click(function()
	  {
		  clickHandler_long();
	  });
  
	  $(defCard).click(function()
	  {
		  clickHandler_long();
	  });
	  
//ADD another CSS source to reflect various element property changes for a long definition format (cascades over the original main.css
	
		  var links = window.document.getElementsByTagName('link');
		  
	  $(links).each(function() {
		var theHRef = $(this).attr('href')// this is your href for the link tag in the loop
		if(theHRef != "css/main_long.css"){
			
		  
		  var aLink = document.createElement('link');
		  aLink.href = 'css/main_long.css';
		  aLink.rel = 'stylesheet';
		  document.getElementsByTagName('head')[0].appendChild(aLink);
		}
		 
	  });
	  

	  //change a property set in the HTML page
	  $(defCard).removeClass('notecard');
	  $(defCard).addClass('notecard_def');
		  
		
		
		
	}
	else{

	$(wordCard).click(function()
	{
		clickHandler();
	});

	$(defCard).click(function()
	{
		clickHandler();
	});
	
	}
	
	replaceText();
	
	backButton = document.getElementById('backButton');
	nextButton = document.getElementById('nextButton');

	$(backButton).click(function()
	{
		textHandler("back");
	});

	$(nextButton).click(function()
	{
		textHandler("next");
	});
}

/**
 * Dynamically resizes the titleLabel fontSize based on width of text
 */
function initLabels()
{
	// Application title
	//$(titleLabel).text(titleText); //deprecated - title is now set in the index.html file and auto-inserted by tool
	//5/8/2013 title text pulled from xml then set here
	
	$('#titleLabel').text(titleText);
	
	while ($(titleLabel).width() > 600)
	{
		$(titleLabel).css("fontSize", "-=1");
	}
	
	
	
	
	
	//**code below commented out. reasons: redundant-xml load brings in terms, replaceText() loads divs
	// Notecard titles
	//$(".notecardTitle", wordCard).text(wordCardTitleText);
	//$(".notecardText", defCard).html(defCardTitleText);
}

//---------- NOTECARD ANIMATION FUNCTIONALLITY ----------//

/**
 * Animates the definition notecard when either is clicked
 */
function clickHandler()
{
	//alert("clickHandler");

	switch(cardState) {
		case "defIn":
			$(defCard).animate({ left : '395px' }, animationTimer, function() { animCompleteHandler("defOut") });
			break;

		case "defOut":
			$(defCard).animate({ left : '25px' }, animationTimer, function() { animCompleteHandler("defIn") });
			break;

		default:
		// called during animation
	}
	cardState = "animating";
	// disables click functionallity while animating
	
	
	
	
}


function clickHandler_long() {
	
	//alert("clickHandler2");

	switch(cardState) {
		case "defIn":
			$(defCard).animate({ left : '395px' }, animationTimer, function() { animCompleteHandler("defOut") });
			break;

		case "defOut":
			$(defCard).animate({ left : '825px' }, animationTimer, function() { animCompleteHandler("defIn") });
			break;

		default:
		// called during animation
	}
	cardState = "animating";
	// disables click functionallity while animating
	
	
	
	
	
}











/**
 * Changes animation state when the notecard has completed its animation
 */
function animCompleteHandler(newState)
{
	cardState = newState;
	//alert(cardState);
}

//---------- END NOTECARD ANIMATION FUNCTIONALLITY ----------//

//---------- NOTECARD TEXT FUNCTIONALLITY ----------//

/**
 * Replaces text in both notecards
 */
function textHandler(nextState)
{	
	//alert("textHandler");
	
	switch(nextState)
	{	
		case "back":
			if(currentWordIndex > 0)
			{
				currentWordIndex--;
			}
			else
			{
				currentWordIndex = cardLength - 1;
			}
			break;

		case "next":
			if(currentWordIndex < cardLength - 1)
			{
				currentWordIndex++;
			}
			else
			{
				currentWordIndex = 0;
			}
			break;

		default:
			// called during animation
	}
	
	if(termLength=="long"){
	checkCardPosition_long()
		
	}
	else{
	
	checkCardPosition();
	}
	
	
	replaceText();
}

function checkCardPosition()
{
	//alert("checkCardPosition");
	
	if(cardState != "defIn")
	{
		$(defCard).stop(true, false);
		$(defCard).css('left', '25px');
		animCompleteHandler("defIn");
	}
}

function checkCardPosition_long()
{
	//alert("checkCardPosition");
	
	if(cardState != "defIn")
	{
		$(defCard).stop(true, false);
		$(defCard).css('left', '825px');
		animCompleteHandler("defIn");
	}
}


function replaceText()
{
	
	/*$(".notecardText", wordCard).text(wordArray[currentWordIndex]);
	$(".notecardText", defCard).text(defArray[currentWordIndex]);

	$(consoleCount).text((currentWordIndex + 1) + " of " + cardLength);
	
	alert($("#wordCardText").height());
	*/
	$(".notecardText", wordCard).html(wordArray[currentWordIndex]);
	
	//snippet for text resize in the wordCard
	
	if ($("#wordCardText").height() > 100)
	{
		$("#wordCardText").css("fontSize", 20);
	}
	else{
		
		$("#wordCardText").css("fontSize", 30);
	}
	
	//end snippet
	
	$(".notecardText", defCard).html(defArray[currentWordIndex]);
	
	//snippet for text resize in the defCard
	
	if (($(".notecardText", defCard).height() > 10) && ($(".notecardText", defCard).height() <= 258))
	{
		$(".notecardText", defCard).css("fontSize", 13);
	}
	
	else if($(".notecardText", defCard).height() > 258){
		
		$(".notecardText", defCard).css("fontSize", 11);
	}
	
	else if ($(".notecardText", defCard).height() < 10) {
		
		$(".notecardText", defCard).css("fontSize", 16);
	}
	
	//end snippet
	
	$(controlsCount).text((currentWordIndex + 1) + " of " + cardLength);  
}

//---------- END NOTECARD TEXT FUNCTIONALLITY ----------//